%define _prefix /usr/local/bash-audit-4.4

Name: bash-audit
Version: 4.4
Release: 1%{?dist}
Summary: The GNU Bourne Again shell	
Group: System Environment/Shells
License: GPLv3+	
URL: https://yoncan.github.io
Packager: kaiser
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Source0: bash-audit-%{version}.tar.gz
Source1: dot_bash-audit.sh
Source2: dot_bash-audit.sudoer

#BuildRequires:	
#Requires:	

%description
The GNU Bourne Again shell (Bash) is a shell or command language
interpreter that is compatible with the Bourne shell (sh). Bash
incorporates useful features from the Korn shell (ksh) and the C shell
(csh). Most sh scripts can be run by bash without modification.

%prep
%setup -q -n %{name}-%{version}


%build
%configure --prefix=%{_prefix} --with-bash-malloc=no --with-afs
make %{?_smp_mflags}


%install
# clear buildroot
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

# copy file
mkdir -p %{buildroot}/etc/profile.d
install -c -m644 %SOURCE1 %{buildroot}/etc/profile.d/bash-audit.sh

# create key finger
mkdir -p %{buildroot}/var/log
touch %{buildroot}/var/log/ssh_key_finger
chmod 666 %{buildroot}/var/log/ssh_key_finger

# copy sudoers
mkdir -p %{buildroot}/etc/sudoers.d
install -c -m644 %SOURCE2 %{buildroot}/etc/sudoers.d/bash-audit

%post

grep "%{_prefix}/bin/bash" /etc/shells || echo "%{_prefix}/bin/bash" >>/etc/shells
sed -i "s#\(SHELL=\).*#\1%{_prefix}/bin/bash#" /etc/default/useradd

for u in `awk -F ':'  '$NF == "/bin/bash" || $NF == "/bin/sh" || $NF ~ "bash-audit"  {print $1}' /etc/passwd`
do
    chsh -s %{_prefix}/bin/bash $u
done


if ! `grep '# bash audit' /etc/bashrc >/dev/null 2>&1`;then
cat >>/etc/bashrc<<EOF
# bash audit
if [ -n "\${BASH_EXECUTION_STRING}" ];then
    [ -f "/etc/profile.d/bash-audit.sh" ] && source /etc/profile.d/bash-audit.sh
    if [ -z "\${NAME_OF_KEY}" ];then
        NAME_OF_KEY='(null)'
    fi
    logger -t "-bash[\${PPID}]" -s "HISTORY: PID=\${PPID} PPID=\${PPID} User=\${USER} USER=\${NAME_OF_KEY} HOST=\${SSH_CLIENT_HOST} CMD=\${BASH_EXECUTION_STRING}" >/dev/null 2>&1
fi
# end bash audit
EOF

fi


%preun
for u in `awk -F ':'  '$NF ~ "bash-audit" {print $1} ' /etc/passwd`
do
    chsh -s /bin/bash $u
done

#[ -f "/etc/profile.d/bash-audit.sh" ] && rm /etc/profile.d/bash-audit.sh

if `grep '^# bash audit' /etc/bashrc >/dev/null 2>&1`;then
    sed -i "/# bash audit/,/# end bash audit/ d" /etc/bashrc
fi

sed -i "s#\(SHELL=\).*#\1/bin/bash#" /etc/default/useradd
sed -i "/bash-audit/d" /etc/shells


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%files
%defattr(-,root,root,-)
%{_prefix}
/etc/profile.d/bash-audit.sh
/var/log/ssh_key_finger
/etc/sudoers.d/bash-audit



#%doc %{prefix}/docs


%changelog
* Fri Jan 06 2017 YangCan <yoncan@qq.com> - 4.4.0-1
- Rebase to bash-4.4
  Resolves: #1376609
